#!/bin/sh
DB=RAMDB
DB2LOCATION=/opt/ibm/db2/V9.1

echo -n "Enter the name of the database: [$DB]"
read db_input

if [ -z "$db_input" ]
then
   DB=$DB
else
   DB=$db_input
fi

echo -n "Enter the install location of DB2: [$DB2LOCATION]"
read db2location_input

if [ -z "$db2location_input" ]
then
   DB2LOCATION=$DB2LOCATION
else
   DB2LOCATION=$db2location_input
fi

echo
echo Creating Database $DB...
echo
$DB2LOCATION/bin/db2 CREATE DATABASE $DB USING CODESET UTF-8 TERRITORY US  > output.log

CURRENT_USER=`whoami` 

DB2CONTAINERLOCATION=~/$CURRENT_USER/NODE0000/$DB

echo -n "Enter the DB2 Container location of your database: [$DB2CONTAINERLOCATION]"
read db2containerlocation_input

if [ -z "$db2containerlocation_input" ]
then
   DB2CONTAINERLOCATION=$DB2CONTAINERLOCATION
else
   DB2CONTAINERLOCATION=$db2containerlocation_input
fi

echo "CREATE BUFFERPOOL IBMDEFAULTBP16K IMMEDIATE SIZE 250 PAGESIZE 16 K;" > ~/db_tempspaces.sql
echo "CREATE SYSTEM TEMPORARY TABLESPACE TEMPSPACE16K PAGESIZE 16 K MANAGED BY SYSTEM USING ('$DB2CONTAINERLOCATION/TMPSPACE16K' ) EXTENTSIZE 8 OVERHEAD 12.67 PREFETCHSIZE 8 TRANSFERRATE 0.18 BUFFERPOOL IBMDEFAULTBP16K;" >> ~/db_tempspaces.sql
echo "CREATE USER TEMPORARY TABLESPACE UTMPSPACE16K PAGESIZE 16 K MANAGED BY SYSTEM USING ('$DB2CONTAINERLOCATION/LOCALUTF/UTMPSPACE16K' ) EXTENTSIZE 8 OVERHEAD 12.67 PREFETCHSIZE 8 TRANSFERRATE 0.18 BUFFERPOOL IBMDEFAULTBP16K;" >> ~/db_tempspaces.sql
echo "CREATE REGULAR TABLESPACE USERSPACE16K PAGESIZE 16 K MANAGED BY SYSTEM USING ('$DB2CONTAINERLOCATION/LOCALUTF/USERSPACE16K' ) EXTENTSIZE 8 OVERHEAD 12.67 PREFETCHSIZE 8 TRANSFERRATE 0.18 BUFFERPOOL IBMDEFAULTBP16K DROPPED TABLE RECOVERY OFF;" >> ~/db_tempspaces.sql

echo
echo Creating temp spaces in $DB2CONTAINERLOCATION for $DB
echo
$DB2LOCATION/bin/db2batch -d $DB -f ~/db_tempspaces.sql >> output.log  2>&1
$DB2LOCATION/bin/db2batch -d $DB -f RAMSCHEMA.sql >> output.log  2>&1
$DB2LOCATION/bin/db2batch -d $DB -f bootStrap.sql >> output.log  2>&1

echo
echo view output.log for the results.
echo







