-- <ScriptOptions statementTerminator="GO" />
-- Delete the tables in bottom up order so that foreign key references are deleted before
-- the parent table is deleted.
DELETE FROM RAMSCHEMA.ATTACHMENT
GO

DELETE FROM RAMSCHEMA.POST
GO

DELETE FROM RAMSCHEMA.TOPIC
GO

DELETE FROM RAMSCHEMA.FORUM
GO

DELETE FROM RAMSCHEMA.STALECACHE
GO

DELETE FROM RAMSCHEMA.PTQUERY
GO

DELETE FROM RAMSCHEMA.PTCONFIG_USER
GO

DELETE FROM RAMSCHEMA.PTCONFIG_UGR
GO

DELETE FROM RAMSCHEMA.PTCONFIG
GO

DELETE FROM RAMSCHEMA.PTREPO
GO

DELETE FROM RAMSCHEMA.SUBSCRIPTION
GO

DELETE FROM RAMSCHEMA.REVIEW_PROCESS
GO

DELETE FROM RAMSCHEMA.CONFIGURATION
GO

DELETE FROM RAMSCHEMA.REPOSITORYMETRIC
GO

DELETE FROM RAMSCHEMA.USERRELATIONSHIP 
GO

DELETE FROM RAMSCHEMA.UGRP_RELATIONSHIP 
GO

DELETE FROM RAMSCHEMA.GROUPUSERROLE 
GO

DELETE FROM RAMSCHEMA.TAG
GO

DELETE FROM RAMSCHEMA.TODO_TARGET_UGRP
GO

DELETE FROM RAMSCHEMA.TODO
GO

DELETE FROM RAMSCHEMA.USERGROUP
GO

DELETE FROM RAMSCHEMA.USER_PREFERENCES
GO

DELETE FROM RAMSCHEMA.USERID 
GO

DELETE FROM RAMSCHEMA.REPOSROLEENTITLEMENT 
GO

DELETE FROM RAMSCHEMA.REPOSITORYROLE 
GO

DELETE FROM RAMSCHEMA.AUTOKEYGEN 
GO

DELETE FROM RAMSCHEMA.ASSETVERSIONHISTORY 
GO

DELETE FROM RAMSCHEMA.ASSET 
GO

DELETE FROM RAMSCHEMA.STATE 
GO

DELETE FROM RAMSCHEMA.ASSETTYPE 
GO

DELETE FROM RAMSCHEMA.REVIEW_PROCESS
GO

DELETE FROM RAMSCHEMA.RESOURCEGROUP 
GO

DELETE FROM RAMSCHEMA.CLASSIFSCHEMA
GO

DELETE FROM RAMSCHEMA.ASSETRELATIONTYPE
GO

INSERT INTO RAMSCHEMA.CONFIGURATION (CONFIG_KEY, VALUE) VALUES('ram.repositoryVersion', '7.0.0.1.v20070827') 
GO

INSERT INTO RAMSCHEMA.CONFIGURATION (CONFIG_KEY, VALUE) VALUES('ram.indexVersion', '7.0.0.2.v20071001') 
GO

INSERT INTO RAMSCHEMA.CONFIGURATION (CONFIG_KEY, VALUE) VALUES('ram.serverPath', 'http://somserver.ibm.com/') 
GO

INSERT INTO RAMSCHEMA.CONFIGURATION (CONFIG_KEY, VALUE) VALUES('com.ibm.ram.ws.path', 'http://somserver.ibm.com/') 
GO

INSERT INTO RAMSCHEMA.ASSETRELATIONTYPE (NAME, DISPLAY_NAME) VALUES('dependent', 'Dependent')
GO

INSERT INTO RAMSCHEMA.ASSETRELATIONTYPE (NAME, DISPLAY_NAME, REVERSE_NAME) VALUES('dependency', 'Dependency', 'dependent')
GO

INSERT INTO RAMSCHEMA.ASSETRELATIONTYPE (NAME, DISPLAY_NAME) VALUES('parent', 'Parent')
GO

INSERT INTO RAMSCHEMA.ASSETRELATIONTYPE (NAME, DISPLAY_NAME, REVERSE_NAME) VALUES('aggregation', 'Aggregation', 'parent')
GO

INSERT INTO RAMSCHEMA.ASSETRELATIONTYPE (NAME, DISPLAY_NAME) VALUES('tutoree', 'Tutorial for')
GO

INSERT INTO RAMSCHEMA.ASSETRELATIONTYPE (NAME, DISPLAY_NAME, REVERSE_NAME) VALUES('tutorial', 'Tutorial', 'tutoree')
GO

INSERT INTO RAMSCHEMA.ASSETRELATIONTYPE (NAME, DISPLAY_NAME) VALUES('testee', 'Test for')
GO

INSERT INTO RAMSCHEMA.ASSETRELATIONTYPE (NAME, DISPLAY_NAME, REVERSE_NAME) VALUES('test', 'Test', 'testee')
GO

INSERT INTO RAMSCHEMA.ASSETRELATIONTYPE (NAME, DISPLAY_NAME) VALUES('specification', 'Specification')
GO

INSERT INTO RAMSCHEMA.ASSETRELATIONTYPE (NAME, DISPLAY_NAME, REVERSE_NAME) VALUES('implementation', 'Implementation', 'specification')
GO

INSERT INTO RAMSCHEMA.ASSETRELATIONTYPE (NAME, DISPLAY_NAME) VALUES('nextversion', 'Next version')
GO

INSERT INTO RAMSCHEMA.ASSETRELATIONTYPE (NAME, DISPLAY_NAME, REVERSE_NAME) VALUES('previousversion', 'Previous version', 'nextversion')
GO

-- Certain ID's are hardcoded and required.
-- User ID 0 - AnyUser (Anonymous) - the external id is hard coded too: ram.anyuser
-- User ID 1 - RegisteredUser - the external id is hard coded too: ram.registereduser
-- Group ID 0 - Repository Admin Group
-- Role ID 0 - Default Admin Role
-- Role ID 1 - Default Owner Role

-- State ID 1 - Draft
-- State ID 2 - Plan review
-- State ID 3 - Review
-- State ID 4 - Evaluate review
-- State ID 5 - Approved
-- State ID 6 - Retired
-- State ID 7 - As is
-- State ID 8 - Archived

-- Build the Resource Group table.

INSERT INTO RAMSCHEMA.RESOURCEGROUP (ID, NAME, DESCRIPTION) VALUES (0, 'Repository Admin Group', 'Master Administration group. Not used for assets.') 
GO

INSERT INTO RAMSCHEMA.REPOSITORYROLE (ID, NAME, RESOURCEGROUPID, ROLE_TYPE, DESCRIPTION) VALUES (0, 'Administrator', 0, 1, 'Has administration capability.')
GO

INSERT INTO RAMSCHEMA.REPOSITORYROLE (ID, NAME, RESOURCEGROUPID, ROLE_TYPE, TEST_DATA, DESCRIPTION) VALUES (1, 'Asset Owner', 0, 2, '<?xml version="1.0" encoding="UTF-8"?><sdo:AssetOwnerTest xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:sdo="http:///com/ibm/ram/repository/sdo.ecore"/>', 'Owners of assets will have the capabilities of this role for assets that they own.')
GO

INSERT INTO RAMSCHEMA.REPOSITORYROLE (ID, NAME, RESOURCEGROUPID, DESCRIPTION) VALUES (2, 'Asset Producer', 0, 'Can upload and create assets.')
GO

INSERT INTO RAMSCHEMA.REPOSITORYROLE (ID, NAME, RESOURCEGROUPID, DESCRIPTION) VALUES (3, 'Asset Consumer', 0, 'Can browse and download assets.')
GO

INSERT INTO RAMSCHEMA.REPOSITORYROLE (ID, NAME, RESOURCEGROUPID, ROLE_TYPE, TEST_DATA, DESCRIPTION) VALUES (4, 'Asset Reviewer', 0, 2, '<?xml version="1.0" encoding="UTF-8"?><sdo:ReviewerTest xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:sdo="http:///com/ibm/ram/repository/sdo.ecore"/>', 'Reviewers can review an asset.')
GO

INSERT INTO RAMSCHEMA.REPOSITORYROLE (ID, NAME, RESOURCEGROUPID, ROLE_TYPE, TEST_DATA, DESCRIPTION) VALUES (5, 'Asset Review Board', 0, 2, '<?xml version="1.0" encoding="UTF-8"?><sdo:ReviewBoardTest xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:sdo="http:///com/ibm/ram/repository/sdo.ecore"/>', 'Review board members can run a review for an asset.')
GO

-- Entitlements Table, the entitlement ids are just numbers. There is a EMF Enumeration that relates the numbers to their meaning.
-- Entitlements are:
-- 0	Admin
-- 1	Use schema - not used
-- 2	Create asset
-- 3	Search asset
-- 4	Update asset
-- 5	Delete asset
-- 6	Download asset
-- 7	Review asset
-- 8	Subscribe to asset
-- 9	Review board
-- 10	Browse artifact - not used
-- 11	Create schema - not used
-- 12	Add artifact to asset - not used
-- 13   Read asset detail
-- 14   Browse asset
-- 15   Forum Admin
-- 16   Publish Admin

-- Console admin
INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(0, 0) 
GO

-- Asset Producer role
INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(2, 2) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(2, 3) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(2, 4) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(2, 6) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(2, 8) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(2, 13) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(2, 14) 
GO

-- Asset Consumer role
INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(3, 3) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(3, 6) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(3, 8) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(3, 13) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(3, 14) 
GO

-- Asset Reviewer role
INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(4, 3) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(4, 4) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(4, 6) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(4, 7) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(4, 8) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(4, 13) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(4, 14) 
GO

-- Asset Review Board role
INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(5, 3) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(5, 4) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(5, 5) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(5, 6) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(5, 8) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(5, 9) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(5, 13) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(5, 14) 
GO

-- Asset Owner
INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(1, 3) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(1, 4) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(1, 5) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(1, 6) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(1, 8) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(1, 13) 
GO

INSERT INTO RAMSCHEMA.REPOSROLEENTITLEMENT (REPOSROLEID, ENTITLEID) VALUES(1, 14) 
GO

-- Standard Users
INSERT INTO RAMSCHEMA.USERID (ID, NAME, USERID, EMAIL_FORMAT) VALUES (0, 'Anonymous User', 'ram.anyuser', 1) 
GO

INSERT INTO RAMSCHEMA.USERID (ID, NAME, USERID, EMAIL_FORMAT) VALUES (1, 'Signed-in users', 'ram.registereduser', 1) 
GO

INSERT INTO RAMSCHEMA.USERID (ID, NAME, EMAIL, PHONE, USERID, EMAIL_FORMAT) VALUES (100, 'Master Administrator', 'admin@somwhere.com', '555-4556', 'admin', 1) 
GO

-- User Admin has Repository Admin Group access
INSERT INTO RAMSCHEMA.GROUPUSERROLE (USERID, REPOSITORYROLEID) VALUES (100, 0) 
GO

-- Registered user must have the special roles Review Board, Reviewer, and Asset Owner for the system to work correctly.
INSERT INTO RAMSCHEMA.GROUPUSERROLE (USERID, REPOSITORYROLEID) VALUES (1, 1) 
GO

INSERT INTO RAMSCHEMA.GROUPUSERROLE (USERID, REPOSITORYROLEID) VALUES (1, 4) 
GO

INSERT INTO RAMSCHEMA.GROUPUSERROLE (USERID, REPOSITORYROLEID) VALUES (1, 5) 
GO

-- Build the state table.
INSERT INTO RAMSCHEMA.STATE (ID, NAME) VALUES(1, 'Draft') 
GO

INSERT INTO RAMSCHEMA.STATE (ID, NAME) VALUES(2, 'Plan review') 
GO

INSERT INTO RAMSCHEMA.STATE (ID, NAME) VALUES(3, 'Review') 
GO

INSERT INTO RAMSCHEMA.STATE (ID, NAME) VALUES(4, 'Evaluate review') 
GO

INSERT INTO RAMSCHEMA.STATE (ID, NAME) VALUES(5, 'Approved') 
GO

INSERT INTO RAMSCHEMA.STATE (ID, NAME) VALUES(6, 'Retired') 
GO

INSERT INTO RAMSCHEMA.STATE (ID, NAME) VALUES(7, 'As is') 
GO

INSERT INTO RAMSCHEMA.STATE (ID, NAME) VALUES(8, 'Archived') 
GO

-- Add an empty asset type schema.
INSERT INTO RAMSCHEMA.CLASSIFSCHEMA (URI, FRAGMENT, NAME, LAST_MODIFIED, CL_SCHEMA) VALUES('classif/assetTypesSchema.xmi','/','AssetTypes', CURRENT_TIMESTAMP, '<?xml version="1.0" encoding="UTF-8"?><defaultprofile:ClassificationSchema xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:defaultprofile="http:///defaultprofile.ecore" name="AssetTypes"><descriptor xsi:type="defaultprofile:NodeDescriptor" xmi:id="comibmramassettypenode" name="AssetType" exclusive="true"><description value="Asset Type Definitions"/></descriptor><descriptor xsi:type="defaultprofile:NodeDescriptor" xmi:id="comibmramrestrictednode" name="RestrictedAttributes" exclusive="false"><description value="Restricted Attribute Definitions"/></descriptor></defaultprofile:ClassificationSchema>')
GO

INSERT INTO RAMSCHEMA.AUTOKEYGEN (NEXT_USER, NEXT_RESOURCEGROUP, NEXT_REPOSITORYROLE, NEXT_STATE, NEXT_ASSETTYPE, NEXT_ASSET, NEXT_METRIC) VALUES(1000, 1000, 1000, 1000, 1000, 1000, 100) 
GO
